// ModuleClass strtok (string tokenizer)

#ifndef IG_MODULE_CLASS_STRTOK_AS	// CN[hEK[h
#define IG_MODULE_CLASS_STRTOK_AS

#module strtok mBuf, mSplitter, mIndex, mlenBuf, mlenSplitter

// }N
#define global strtok_new(%1, %2, %3) newmod %1, strtok@, %2, %3
#define global strtok_delete(%1) delmod %1

//------------------------------------------------
// strtok \z
// 
// @prm sBuf     : ؂eLXg
// @prm splitter : ؂蕶
//------------------------------------------------
#modinit str sBuf, str splitter
	
	mBuf      = sBuf
	mSplitter = splitter
	mIndex    = 0
	
	mlenBuf      = strlen(mBuf)
	mlenSplitter = strlen(mSplitter)
	
	return
	
//------------------------------------------------
// ؂o
//------------------------------------------------
#modcfunc strtok_getnext
	if ( strtok_isFinished(thismod) ) {		// ɊĂ
		return ""
	}
	
	// ̋؂蕶
	i = instr( mBuf, mIndex, mSplitter )
	if ( i < 0 ) {
		i = mlenBuf - mIndex	// c肷ׂ
	}
	
	// 
	sResult = strmid( mBuf, mIndex, i )
	
	mIndex += i
	mIndex += mlenSplitter	// ؂蕶΂
	
	return sResult
	
//------------------------------------------------
// łɎoĂ邩
//------------------------------------------------
#modcfunc strtok_isFinished
	return (mlenBuf <= mIndex)
	
#global

// TvEXNvg
#if 0		// (0 ȊOȂTvs)

	// if[^ (Ƃݒ)
	// eśui,P,݌ɐvƂƂɂ
	// (liݒ肪ɃeLg[Ȃ͎̂dlł)
	buf = {"
		S,100,30
		݂,170,12
		Ԃǂ,1600,2
	"}
	
	// buf  strtok ŕ (sŋ؂)
	newmod lineToker, strtok, buf, "\n"
;	strtok_new lineToker, buf, "\n"		// }Ngƌ₷
	
	// ׂĂ̍sɂāA1s
	repeat
		if ( strtok_isFinished( lineToker ) ) {
			break
		}
		
		// so
		data = strtok_getnext( lineToker )
		if ( data == "" ) { continue }
		
		// data 𕪉 ( "," ŋ؂ )
		newmod dataToker, strtok, data, ","
	;	strtok_new dataToker, data, ","
		
		name(cnt)  =      strtok_getnext( dataToker )
		price(cnt) = int( strtok_getnext( dataToker ) )
		stock(cnt) = int( strtok_getnext( dataToker ) )
		
		strtok_delete dataToker	// dataToker j
		
		cntItem ++
	loop
	
	strtok_delete lineToker		// K delete AƂKv͂Ȃ
	
	// iXgč\
	repeat cntItem
		mes strf("u%sv͒P %d ~ŁA%d ̍݌ɂ܂B", name(cnt), price(cnt), stock(cnt))
	loop
	
	stop
	
#endif
